Bug 521190 - expf math function very slow
Summary: expf math function very slow
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Fedora
Classification: Fedora
Component: glibc
Version: 14
Hardware: x86_64
OS: Linux
low
high
Target Milestone: ---
Assignee: Jeff Law
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-09-04 08:02 UTC by Roderick Johnstone
Modified: 2016-11-24 15:54 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-01-24 17:01:02 UTC


Attachments (Terms of Use)
Example program to show slowness of expf function (151 bytes, application/octet-stream)
2009-09-04 08:02 UTC, Roderick Johnstone
no flags Details

Description Roderick Johnstone 2009-09-04 08:02:56 UTC
Created attachment 359767 [details]
Example program to show slowness of expf function

Description of problem:

Single precision expf function is 5.5x slower than double precision exp function on x86_64.

Version-Release number of selected component (if applicable):
glibc-2.9-3.x86_64

How reproducible:
Every time

Steps to Reproduce:
1. Download attached file test.f
2. gfortran test.f
3. time ./a.out
  
Actual results:
  4.4816890

real    0m28.698s
user    0m28.467s
sys     0m0.089s 

Expected results:
gfortran -fdefault-real-8 test.f
time ./a.out

   4.4816890703380645

real    0m5.134s
user    0m5.082s
sys     0m0.016s 


Additional info:

Still present in F12 alpha, glibc-2.10.90-12.x86_64.

Above is simplest test case I could make. I originally noticed the problem running a 1000 line single precision code and comparing run times when compiled with g77 and gfortran. g77 calls the double precision exp function whereas gfortran calls the single precision expf function. The runtime when compiling with g77was x2 - x3 faster than using gfortran.

Also noticed similar type of problems with sin function reported at:
http://sources.redhat.com/bugzilla/show_bug.cgi?id=5997
and
http://sourceware.org/bugzilla/show_bug.cgi?id=5781

This problem doesnt seem to show up on the 32-bit architecture.

Comment 1 Bug Zapper 2009-11-18 10:05:47 UTC
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 2 Bug Zapper 2009-12-18 09:42:19 UTC
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 3 Roderick Johnstone 2009-12-18 10:51:25 UTC
Still present in Fedora 12 so reopening with "Version" set to "12".

Changing "Status" from "CLOSED" back to "ASSIGNED".

Comment 4 Bug Zapper 2010-11-04 10:12:56 UTC
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 5 Roderick Johnstone 2010-11-09 15:15:05 UTC
Still present in Fedora 14 so changing "Version" set to "14".

Comment 6 Fedora Admin XMLRPC Client 2011-11-14 19:44:20 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 7 Jeff Law 2012-01-24 17:01:02 UTC
Known issue with 64bit exp, upstream glibc has already made it pretty clear they're not going to change this code unless someone comes up with code that has the same accuracy.


Note You need to log in before you can comment on or make changes to this bug.